#![allow(clippy::never_loop)]
#![allow(clippy::let_and_return)]

mod bot;
mod db_types;
mod init_db;

use std::env;

use bot::run_bot;
use init_db::{fetch_and_insert_data, initialize_db};
use rusqlite::Connection;


#[tokio::main]
async fn main() {
	let mut conn = Connection::open("./shitty_wizard.db").unwrap();

	let should_refresh_db = loop {
		if env::args().any(|a| a == "--refresh-db") {
			break true;
		}

		let count: usize =
			match conn
				.query_row("SELECT COUNT(*) FROM responses", (), |r| r.get(0))
			{
				Ok(count) => count,
				Err(_) => break true,
			};

		break count == 0;
	};

	if should_refresh_db {
		initialize_db(&mut conn).unwrap();
		fetch_and_insert_data(&mut conn).await.unwrap();
	};

	run_bot(conn).await.unwrap();
}
